/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.codegen;

import static mc.umlp.arc.MontiArcConstants.MONTI_ARC_ROOT_NAME;
import static mc.umlp.arcd.ToolConstants.ARG_ANALYSIS;
import static mc.umlp.arcd.ToolConstants.ARG_GENERATOR;
import static mc.umlp.arcd.ToolConstants.ARG_MODELPATH;
import static mc.umlp.arcd.ToolConstants.ARG_OUT;
import static mc.umlp.arcd.ToolConstants.ARG_SYMTABDIR;
import static mc.umlp.arcd.ToolConstants.ARG_SYNTHESIS;
import static mc.umlp.arcd.ToolConstants.PARAM_ALL;
import static mc.umlp.arcd.ToolConstants.ROOT_NAME_JAVA;
import static mc.umlp.arcd.ToolConstants.WF_CREATE_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_INIT_CHECK;
import static mc.umlp.arcd.ToolConstants.WF_INIT_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_PARSE;
import static mc.umlp.arcd.ToolConstants.WF_PRE_CHECK_TRAFO;
import static mc.umlp.arcd.ToolConstants.WF_RUN_CHECK;

import com.google.inject.AbstractModule;

import mc.umlp.arc.MontiArcGeneratorConstants;
import mc.umlp.arc.MontiArcGeneratorTool;
import de.montiarc.extension.examples.helper.ToolCfgConstants;
import de.montiarc.extension.examples.syntax._ast.ASTMCCompilationUnit;

/**
 * TODO: Write me!
 * 
 * @author (last commit) $Author: ahaber $
 * @version $Revision: 3032 $, $Date: 2014-10-11 18:37:43 +0000 (Sat, 11 Oct 2014) $
 * @since TODO: add version number
 */
public class StartExtendedCodegen implements ToolCfgConstants {  
  
  public static void main(String[] args) {
    String startNode = ASTMCCompilationUnit.class.getName();
    
    // configuration to parse and count ports.
    String[] toolArgs = new String[] {
        "src/main/resources/syntax/MontiArcWithSCComp.arc",
        ARG_OUT, OUT_DIR,
        ARG_SYMTABDIR, SYMTAB_DIR,
        ARG_MODELPATH, "src/main/resources",
        ARG_ANALYSIS, PARAM_ALL, WF_PARSE,
        ARG_ANALYSIS, ROOT_NAME_JAVA, "setname",
        ARG_ANALYSIS, ROOT_NAME_JAVA, "addImports",
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_INIT_SYMTAB,
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_CREATE_SYMTAB,
        ARG_SYNTHESIS, PARAM_ALL, WF_INIT_CHECK,
        ARG_SYNTHESIS, MONTI_ARC_ROOT_NAME, WF_PRE_CHECK_TRAFO,
        ARG_SYNTHESIS, PARAM_ALL, WF_RUN_CHECK,
        ARG_GENERATOR, "de.montiarc.extension.examples.codegen.ComponentWithSCMain", startNode,
        ARG_GENERATOR, MontiArcGeneratorConstants.INTERFACE_GENERATOR, startNode,
        ARG_GENERATOR, "de.montiarc.extension.examples.codegen.ComponentWithSCFactoryMain", startNode
    };
    // create tool with custom dependency injection module
    AbstractModule  mod = new SyntaxExtGenModule();
    MontiArcGeneratorTool tool = new MontiArcGeneratorTool(toolArgs, mod);
    // execute tool
    tool.run();
    
  }
}
