/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.codegen;

import static mc.umlp.arc.MontiArcConstants.MONTI_ARC_ROOT_NAME;
import static mc.umlp.arcd.ToolConstants.WF_CREATE_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_INIT_CHECK;
import static mc.umlp.arcd.ToolConstants.WF_PARSE;
import static mc.umlp.arcd.ToolConstants.WF_PRE_CHECK_TRAFO;
import static mc.umlp.arcd.ToolConstants.WF_PRE_CODEGEN_TRAFO;
import interfaces2.language.ILanguage;
import interfaces2.language.ModelingLanguage;
import interfaces2.workflows.CreateExportedInterfaceWorkflow;
import interfaces2.workflows.PrepareCheckWorkflow;
import mc.DSLRootFactory;
import mc.IErrorDelegator;
import mc.IModelInfrastructureProvider;
import mc.umlp.arc.MontiArcGeneratorDefaultModule;
import mc.umlp.arc.MontiArcGeneratorLanguage;
import mc.umlp.arc.codegen.transform.PreCodegenTransformationWorkflow;
import mc.umlp.arc.ets.transform.PreCoCoCheckMontiArcTransformationWorkflow;
import mc.umlp.arcd.ets.factories.ComponentImplementationEntryCreatorManager;
import mc.umlp.arcd.ets.factories.IComponentImplementationEntryCreatorManager;

import com.google.inject.Inject;
import com.google.inject.Provides;

import de.montiarc.extension.examples.syntax._tool.ExtendedMontiArcParsingWorkflow;
import de.montiarc.extension.examples.syntax._tool.ExtendedMontiArcRoot;
import de.montiarc.extension.examples.syntax._tool.ExtendedMontiArcRootFactory;
import de.montiarc.extension.examples.syntax.ets.ArcSCImplementationEntryCreator;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3045 $,
 *          $Date: 2014-10-26 16:29:18 +0000 (Sun, 26 Oct 2014) $
 * @since   TODO: add version number
 *
 */
public class SyntaxExtGenModule extends MontiArcGeneratorDefaultModule {
  @Override
  protected void bindMontiArcModelingLanguage() {
    // left empty...we simply override default binding.
  }
  @Inject @Provides
  ModelingLanguage getExtendedMontiArcLanguage(ILanguage component) {
    MontiArcGeneratorLanguage lng = new MontiArcGeneratorLanguage(component) {
      @Override
      public DSLRootFactory<?> getRootFactory(
          IModelInfrastructureProvider ip, IErrorDelegator eh, String enc) {
        return new ExtendedMontiArcRootFactory(ip, eh, enc);
      }
    };
    lng.getDslRootClassForUserNames().put(MONTI_ARC_ROOT_NAME, ExtendedMontiArcRoot.class);
    lng.setRootClass(ExtendedMontiArcRoot.class);
    lng.addExecutionUnit(WF_PARSE, new ExtendedMontiArcParsingWorkflow());
    lng.addExecutionUnit(WF_CREATE_SYMTAB, 
        new CreateExportedInterfaceWorkflow<ExtendedMontiArcRoot>(
        ExtendedMontiArcRoot.class, lng));
    lng.addExecutionUnit(WF_INIT_CHECK, 
        new PrepareCheckWorkflow<ExtendedMontiArcRoot>(
                ExtendedMontiArcRoot.class, lng));
    lng.addExecutionUnit(WF_PRE_CHECK_TRAFO,
        new PreCoCoCheckMontiArcTransformationWorkflow
        <ExtendedMontiArcRoot>(ExtendedMontiArcRoot.class));
    lng.addExecutionUnit(WF_PRE_CODEGEN_TRAFO,
        new PreCodegenTransformationWorkflow
        <ExtendedMontiArcRoot>(ExtendedMontiArcRoot.class));

    return lng;
  }

  @Override
  protected void bindComponentImplementationEntryCreator() {
      // overridden to remove default binding
  }
  
  @Provides
  protected IComponentImplementationEntryCreatorManager createImplCreationManager() {
    ComponentImplementationEntryCreatorManager result = new ComponentImplementationEntryCreatorManager();
    result.addCreator(new ArcSCImplementationEntryCreator());
    return result;
  }
}
