/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.processing;

import static mc.umlp.arc.MontiArcConstants.MONTI_ARC_ROOT_NAME;
import static mc.umlp.arcd.ToolConstants.ARG_ANALYSIS;
import static mc.umlp.arcd.ToolConstants.ARG_MODELPATH;
import static mc.umlp.arcd.ToolConstants.ARG_OUT;
import static mc.umlp.arcd.ToolConstants.ARG_SYNTHESIS;
import static mc.umlp.arcd.ToolConstants.PARAM_ALL;
import static mc.umlp.arcd.ToolConstants.ROOT_NAME_JAVA;
import static mc.umlp.arcd.ToolConstants.WF_CREATE_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_INIT_CHECK;
import static mc.umlp.arcd.ToolConstants.WF_INIT_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_PARSE;
import static mc.umlp.arcd.ToolConstants.WF_PRETTY_PRINT;
import static mc.umlp.arcd.ToolConstants.WF_PRE_CHECK_TRAFO;
import de.montiarc.extension.examples.helper.ToolCfgConstants;
import mc.umlp.arc.MontiArcDefaultModule;
import mc.umlp.arc.MontiArcTool;
import mc.umlp.arcd.ets.transform.ITrafoConfigurationFactory;

/**
 * Demonstrates how to add custom transformations to a MontiArc tool.
 * 
 * @author (last commit) $Author: ahaber $
 * @version $Revision: 3032 $, $Date: 2014-10-11 18:37:43 +0000 (Sat, 11 Oct 2014) $
 * @since 2.5.0
 */
public class AddTrafo implements ToolCfgConstants {
  
  static class AddTrafoModule extends MontiArcDefaultModule {
    /**
     * @see mc.umlp.arc.MontiArcDefaultModule#bindTrafoConfigurationFactory()
     */
    @Override
    protected void bindTrafoConfigurationFactory() {
      bind(ITrafoConfigurationFactory.class).to(CustomTrafoConfigFactory.class);
    }
  }
  
  public static void main(String[] args) {
    String[] toolArgs = new String[] {
        "src/main/resources/processing/Expand.arc",
        ARG_MODELPATH, "src/main/resources",
        ARG_OUT, OUT_DIR,
        ARG_ANALYSIS, PARAM_ALL, WF_PARSE,
        ARG_ANALYSIS, ROOT_NAME_JAVA, "setname",
        ARG_ANALYSIS, ROOT_NAME_JAVA, "addImports",
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_INIT_SYMTAB,
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_CREATE_SYMTAB,
        ARG_SYNTHESIS, PARAM_ALL, WF_INIT_CHECK,
        ARG_SYNTHESIS, MONTI_ARC_ROOT_NAME, WF_PRE_CHECK_TRAFO,
        ARG_SYNTHESIS, PARAM_ALL, WF_PRETTY_PRINT,
    };
    MontiArcTool t = new MontiArcTool(toolArgs, new AddTrafoModule());
    t.run();
  }
  
}
