/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax;

import static mc.umlp.arc.MontiArcConstants.MONTI_ARC_ROOT_NAME;
import static mc.umlp.arcd.ToolConstants.*;
import static mc.umlp.arcd.ToolConstants.ARG_MODELPATH;
import static mc.umlp.arcd.ToolConstants.ARG_SYNTHESIS;
import static mc.umlp.arcd.ToolConstants.PARAM_ALL;
import static mc.umlp.arcd.ToolConstants.ROOT_NAME_JAVA;
import static mc.umlp.arcd.ToolConstants.WF_CREATE_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_INIT_CHECK;
import static mc.umlp.arcd.ToolConstants.WF_INIT_SYMTAB;
import static mc.umlp.arcd.ToolConstants.WF_PARSE;
import static mc.umlp.arcd.ToolConstants.WF_PRE_CHECK_TRAFO;
import static mc.umlp.arcd.ToolConstants.WF_RUN_CHECK;
import de.montiarc.extension.examples.helper.ToolCfgConstants;
import mc.umlp.arc.MontiArcTool;

/**
 * Using the extended MontiArc tool.
 * 
 * @author (last commit) $Author: ahaber $
 * @version $Revision: 3032 $, $Date: 2014-10-09 11:04:36 +0200 (Do, 09 Okt
 * 2014) $
 * @since 2.5.0
 */
public class ExtendedMontiArcUsage implements ToolCfgConstants {
  
  public static void main(String[] args) {
    // configuration to parse and count ports.
    String[] toolArgs = new String[] {
        "src/main/resources/syntax",
        ARG_OUT, OUT_DIR,
        ARG_SYMTABDIR, SYMTAB_DIR,
        ARG_MODELPATH, "src/main/resources",
        ARG_ANALYSIS, PARAM_ALL, WF_PARSE,
        ARG_ANALYSIS, ROOT_NAME_JAVA, "setname",
        ARG_ANALYSIS, ROOT_NAME_JAVA, "addImports",
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_INIT_SYMTAB,
        ARG_ANALYSIS, MONTI_ARC_ROOT_NAME, WF_CREATE_SYMTAB,
        ARG_SYNTHESIS, PARAM_ALL, WF_INIT_CHECK,
        ARG_SYNTHESIS, MONTI_ARC_ROOT_NAME, WF_PRE_CHECK_TRAFO,
        ARG_SYNTHESIS, PARAM_ALL, WF_RUN_CHECK,
    };
    // create tool with custom dependency injection module
    MontiArcTool tool = new MontiArcTool(toolArgs, new SyntaxExtModule());
    // execute tool
    boolean success = tool.run();
    if (success) {
      System.out.println("Parsed and processed extended MontiArc models.");
    }
    else {
      System.err.println("Failed to process extended MontiArc models!");
      System.exit(-1);
    }
  }
}
