/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax.ets;

import java.util.List;

import mc.ets.serialization.STEntrySerializer.Serialized;
import mc.umlp.arc.MontiArcConstants;
import mc.umlp.arcd.ArcdConstants;
import mc.umlp.arcd.ets.entries.AbstractSTEntry;

import com.google.common.collect.Lists;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3031 $,
 *          $Date: 2014-10-10 11:05:58 +0000 (Fri, 10 Oct 2014) $
 * @since   2.5.0
 *
 */
public class ArcSCEntry extends AbstractSTEntry<ArcSCEntry> {
  
  public static final String KIND = "ArcSCEntry";
  
  @Serialized
  private final List<String> states = Lists.newArrayList();
  
  /**
   * Constructor for de.montiarc.extension.examples.syntax.ets.ArcSCEntry
   * @param defaultSymtabKindToBeLoaded
   */
  protected ArcSCEntry() {
    super(ArcdConstants.ST_KIND_PROTECTED);
  }

  /**
   * @see interfaces2.STEntry#getLanguage()
   */
  @Override
  public String getLanguage() {
    return MontiArcConstants.MONTI_ARC_LANGUAGE_ID;
  }
  
  /**
   * @see interfaces2.STEntry#getKind()
   */
  @Override
  public String getKind() {
    return KIND;
  }

  /**
   * @return states
   */
  public List<String> getStates() {
    ArcSCEntry best = getBestKnownVersion();
    if (best == this) {
      return this.states;
    }
    else {
      return best.states;      
    }
  }

  /**
   * @param states the states to set
   */
  public void addState(String state) {
    this.states.add(state);
  }
  
}
