/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax.ets;

import static com.google.common.base.Preconditions.checkArgument;
import interfaces2.ISTEntry;
import interfaces2.STEntryState;
import interfaces2.loaders.STEntryDeserializer;

import java.util.List;

import mc.ast.ASTNode;
import mc.ets.serialization._ast.ASTObject;

import com.google.common.collect.Lists;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3031 $,
 *          $Date: 2014-10-10 11:05:58 +0000 (Fri, 10 Oct 2014) $
 * @since   TODO: add version number
 *
 */
public class ArcSCEntryDeserializer extends STEntryDeserializer {

  /**
   * @see interfaces2.loaders.STEntryDeserializer#getKind()
   */
  @Override
  public String getKind() {
    return ArcSCEntry.KIND;
  }

  /**
   * @see interfaces2.loaders.STEntryDeserializer#deserialize(mc.ast.ASTNode)
   */
  @Override
  public ISTEntry deserialize(ASTNode node) {
    checkArgument(node instanceof ASTObject);
    ASTObject object = (ASTObject) node;
    
    ArcSCEntry entry = new ArcSCEntry();
    entry.setEntryState(STEntryState.FULL, entry);
    
    String name = object.<String> getAttributeValue("name").or("");
    entry.setName(name);
    
    
    List<String> states = object.<List<String>> getAttributeValue("states").or(Lists.<String> newArrayList());
    for (String s : states) {
      entry.addState(s);      
    }
    
    return entry;
  }

  /**
   * @see interfaces2.loaders.STEntryDeserializer#deserialize(mc.ast.ASTNode, interfaces2.ISTEntry)
   */
  @Override
  public ISTEntry deserialize(ASTNode description, ISTEntry parent) {
    ArcSCEntry entry = (ArcSCEntry) deserialize(description);
    if (parent instanceof ArcSCImplementationEntry) {
      ArcSCImplementationEntry casted = (ArcSCImplementationEntry) parent;    
      casted.setStateChart(entry);
    }
    return entry;
  }
  
    
}
