/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax.ets;

import interfaces2.STEntryState;
import interfaces2.SymbolTable;

import java.util.List;

import mc.umlp.arcd._ast.ASTArcComponentImplementation;
import mc.umlp.arcd.ets.entries.AComponentImplementationEntry;
import mc.umlp.arcd.ets.entries.ComponentEntry;
import mc.umlp.arcd.ets.factories.AComponentImplementationEntryCreator;
import mc.umlp.arcd.ets.visitors.AbstractArcdSymtabVisitor;
import mc.umlp.sc._ast.ASTSCDefinition;
import mc.umlp.sc._ast.ASTSCState;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3031 $,
 *          $Date: 2014-10-10 11:05:58 +0000 (Fri, 10 Oct 2014) $
 * @since   2.5.0
 *
 */
public class ArcSCImplementationEntryCreator extends AComponentImplementationEntryCreator<ASTSCDefinition> {

  /**
   * Constructor for de.montiarc.extension.examples.syntax.ets.ArcSCImplementationEntryCreator
   * @param checker
   */
  public ArcSCImplementationEntryCreator() {
    super(ASTSCDefinition.class);
    addDeserializer(new ArcSCEntryDeserializer());
    addDeserializer(new ArcSCImplementationEntryDeserializer());
  }

  /**
   * @see mc.umlp.arcd.ets.factories.AComponentImplementationEntryCreator#doCreate(mc.ast.ASTNode, mc.umlp.arcd.ets.entries.ComponentEntry, mc.umlp.arcd.ets.visitors.AbstractArcdSymtabVisitor)
   */
  @Override
  protected AComponentImplementationEntry doCreate(ASTSCDefinition node, ComponentEntry component,
      AbstractArcdSymtabVisitor visitor) {
    ArcSCEntry scEntry = new ArcSCEntry();
    
    scEntry.setName(node.getName());
    for (ASTSCState s : node.getSCStates()) {
      scEntry.addState(s.getName());
    }
    scEntry.setEntryState(STEntryState.FULL, scEntry);
    
    ArcSCImplementationEntry result = new ArcSCImplementationEntry();
    result.setStateChart(scEntry);
    
    result.setEntryState(STEntryState.FULL, result);
    ASTArcComponentImplementation impl = (ASTArcComponentImplementation) node.get_Parent();
    result.setName(impl.getName());
    
    List<SymbolTable> tables = visitor.getAllExportedTables(node.get_Parent());
    for (SymbolTable t : tables) {
        t.addEntry(scEntry);
    }
    List<SymbolTable> tablesComp = visitor.getAllExportedTables(impl.get_Parent());
    for (SymbolTable t : tablesComp) {
        t.addEntry(result);
    }
    return result;
  }


  
  
  
}
