/*
 * Copyright (c) 2014 RWTH Aachen. All rights reserved.
 *
 * http://www.se-rwth.de/
 */
package de.montiarc.extension.examples.syntax.ets;

import static com.google.common.base.Preconditions.checkArgument;
import mc.ast.ASTNode;
import mc.ets.serialization._ast.ASTObject;
import mc.umlp.arcd.ets.entries.ComponentEntry;
import interfaces2.ISTEntry;
import interfaces2.STEntryState;
import interfaces2.loaders.STEntryDeserializer;

/**
 * TODO: Write me!
 *
 * @author  (last commit) $Author: ahaber $
 * @version $Revision: 3031 $,
 *          $Date: 2014-10-10 11:05:58 +0000 (Fri, 10 Oct 2014) $
 * @since   TODO: add version number
 *
 */
public class ArcSCImplementationEntryDeserializer extends STEntryDeserializer {

  /**
   * @see interfaces2.loaders.STEntryDeserializer#getKind()
   */
  @Override
  public String getKind() {
    return ArcSCImplementationEntry.KIND;
  }

  /**
   * @see interfaces2.loaders.STEntryDeserializer#deserialize(mc.ast.ASTNode)
   */
  @Override
  public ISTEntry deserialize(ASTNode node) {
    checkArgument(node instanceof ASTObject);
    ASTObject object = (ASTObject) node;
    
    ArcSCImplementationEntry entry = new ArcSCImplementationEntry();
    entry.setEntryState(STEntryState.FULL, entry);
    
    String name = object.<String> getAttributeValue("name").or("");
    entry.setName(name);
    
    return entry;
  }

  /**
   * @see interfaces2.loaders.STEntryDeserializer#deserialize(mc.ast.ASTNode, interfaces2.ISTEntry)
   */
  @Override
  public ISTEntry deserialize(ASTNode description, ISTEntry parent) {
    ArcSCImplementationEntry entry = (ArcSCImplementationEntry) deserialize(description);
    if (parent instanceof ComponentEntry) {
      ((ComponentEntry) parent).addImplementation(entry);
    }
    return entry;
  }
  
}
