<#if op.callCalculator("mc.umlp.arc.codegen.factories.ComponentFactoryCalculator")>
package ${ast.printPackageWithDot()}${packagePostfix}factories;
<#assign factoryType = ast.printName() + "Factory">
/**
 * This factory produces objects that implement interface
 * {@link ${ast.printPackageWithDot()}${packagePostfix}interfaces.I${ast.getName()}}.<br>
 * <br>
 * Generated with MontiArc ${MontiArcVersion}.<br>
 * @date ${TIME_NOW}<br>
 *
 */
public class ${factoryType} {

    /** Factory singleton instance. */
    protected static ${factoryType} theInstance;

    /** Protected default constructor. */
    protected ${factoryType}() {

    }
    
    /**
     * Registers a concrete factory instance that is used to produce 
     * instances of I${ast.printName()}$.
     *
     * @param factory the factory instance that is to be used
     */ 
    public static void register(${factoryType} factory) {
        if (theInstance == null || theInstance.getClass().equals(${factoryType}.class)) {
            theInstance = factory;
        }
        else {
            throw new RuntimeException("More then one concrete factory registered for ${factoryType}. Current factory class is: " +
                theInstance.getClass().getName() + ", factory class to register: " + factory.getClass().getName());
        }
    }
    
    /**
     * Resets the ${factoryType} to use its default factory.
     */
    public static void reset() {
        theInstance = new ${factoryType}();
    }
  
    /**
     *
     * @return a new ${ast.getName()} component
     */
    public static ${ast.printGenericDefinition()} ${ast.printPackageWithDot()}${packagePostfix}interfaces.I${ast.printName()}${typeParameters} <#t>
          create(${ast.printConfigurationParameters()}) {<#lt>
      if (theInstance == null) {
        theInstance = new ${factoryType}();
      }
      return theInstance.doCreate(${ast.printConfigurationNames()});
    }

    /**
     *
     * @return a new ${ast.getName()} component
     */
    protected ${ast.printGenericDefinition()} ${ast.printPackageWithDot()}${packagePostfix}interfaces.I${ast.printName()}${typeParameters} <#t>
          doCreate(${ast.printConfigurationParameters()}) {<#lt>
      return new ${ast.printPackageWithDot()}${packagePostfix}${ast.printName()}${typeParameters}(${ast.printConfigurationNames()});
    }
}
</#if>
<#foreach inner in ast.getInnerComponents()>
    ${op.callTemplate(
        componentFactory,
        inner.printPackageWithDot() + packagePostfix + "factories." + inner.printName() + "Factory",
        inner)}
</#foreach>